/* ***** BEGIN LICENCE BLOCK *****
 * Version: CePL 1.1
 * 
 * The contents of this file are subject to the Celtx Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.celtx.com/CePL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Celtx Script Manager.
 * 
 * The Initial Developer of the Original Code is Chad House and 4067479
 * Canada Inc. t/a CELTX.
 * 
 * Portions created by Chad House are Copyright (C) 2000-2004 Chad House,
 * parts created by Celtx are Copyright (C) 4067479 Canada Inc. All Rights
 * Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENCE BLOCK ***** */

var tabSet;
var contentSet;
var toMakeActive;
var contentToShow;
var refreshInterval = null;

function doCommand (cmd) {
  top.goDoCommand(cmd);
}

function swapAnchor (tabId) {
  // loop through and make tabs inactive
  tabSet = document.getElementById('tabSet');
  for (i=0;i<tabSet.childNodes.length;i++) {
    tabSet.childNodes[i].className = "offtab";
  }
  
  // make desired tab active
  toMakeActive = document.getElementById(tabId);
  toMakeActive.className = 'ontab'; // insert name of your active tab class
  
  // loop through and make all content hidden
  contentSet = document.getElementById('contentSet');
  for (i=0;i<contentSet.childNodes.length;i++) {
    contentSet.childNodes[i].className = "tabContentHide";
  }
  
  // make content active
  contentToShow = document.getElementById(tabId + 'content');
  contentToShow.className = "tabContentShow";
}

function switch1(div) {
  if (document.getElementById('one')) {
    var option = [ 'one', 'two', 'three', 'four', 'five', 'six', 'seven',
      'eight', 'nine', 'ten', 'eleven', 'twelve' ];
    for(var i=0; i<option.length; i++) {
      obj=document.getElementById(option[i]);
      obj.style.display=(option[i]==div)? "block" : "none";
    }
  }
}


// this will run when the document is fully loaded
function init() {
  refreshProjectList();

  if (top.getIOService().offline)
    return;

  setTimeout("startupPing()", 500);

  var prefObserver = {
    QueryInterface: function (iid) {
      if (iid.equals(Components.interfaces.nsISupports) ||
          iid.equals(Components.interfaces.nsIObserver))
        return this;
      throw Components.results.NS_NOINTERFACE;
    },
    observe: function (subject, topic, data) {
      if (topic != "nsPref:changed" || data != "celtx.inbox.refreshRate")
        return;
      if (refreshInterval) {
        window.clearInterval(refreshInterval);
        refreshInterval = null;
      }
      subject = subject.QueryInterface(Components.interfaces.nsIPrefBranch);
      var rate = subject.getIntPref("celtx.inbox.refreshRate");
      if (rate > 0) {
        rate *= 60000;
        refreshInterval = window.setInterval(reload, rate);
      }
    }
  };

  var pref = Components.classes["@mozilla.org/preferences-service;1"]
    .getService(Components.interfaces.nsIPrefBranch2);
  pref.addObserver("celtx.inbox.refreshRate", prefObserver, false);
}


function startupPing () {
  // Check auto-login pref
  var pref = top.getPrefService().getBranch("celtx.");
  try {
    if (top.gApp.userID && pref.getBoolPref("user.loginOnStartup")) {
      var pwd = pref.getCharPref("user.password");
      top.gApp.authenticateAs(top.gApp.userID, pwd, "get-project",
        attemptedLogin);
    }
  }
  catch (ex) {
    dump("*** splashpage.startupPing: " + ex + "\n");
  }

  var req = new XMLHttpRequest();

  function loaded() {
    if (req.status != 200) {
      return;
    }
    try {
      var div = document.getElementById('notifiercontainer');
      var imp = document.importNode(req.responseXML.documentElement, true);
      imp.removeAttribute("height");
      div.appendChild(imp);

      // KLUDGE: We've got net, so enable the forums display
      /*
      var auxDiv = doc.getElementById('aux');
      auxDiv.style.setProperty('display', 'block', '');
      */
    }
    catch (ex) {
      dump("*** startupPing: " + ex + "\n");
    }
  };

  req.onload = loaded;

  try {
    req.open('GET', top.Cx.STARTUP_URL + '/' + top.Cx.VERSION);
    var channel = req.channel;
    var prompt = new SuppressedAuthPrompt(channel.notificationCallbacks);
    channel.notificationCallbacks = prompt;
    req.send(null);
    reload();
  }
  catch (ex) {
    dump("*** splashpage.init: " + ex + "\n");
  }

  try {
    var rate = pref.getIntPref("inbox.refreshRate");
    if (rate > 0) {
      rate *= 60000;
      refreshInterval = window.setInterval(reload, rate);
    }
  }
  catch (ex) {
    dump("*** splashpage.init: " + ex + "\n");
  }
}


function refreshProjectList () {
  var projs = top.getRecentProjectList();
  if (projs.length == 0)
    return;

  var projlist = document.getElementById("projectlist");
  var insertAfter = document.getElementById("recentprojects");
  var lastdoc = Math.min(projs.length - 1, 3);
  for (var i = lastdoc; i >= 0; --i) {
    var item = document.createElement("li");
    var a = document.createElement("a");
    a.setAttribute("href", "#");
    a.setAttribute("class", "numbered");
    var div = document.createElement("div");
    div.setAttribute("class", "trans");
    div.appendChild(document.createElement("h3"));
    div.appendChild(document.createElement("p"));

    item.appendChild(a);
    item.appendChild(div);

    a.setAttribute("onclick", "projectLinkClicked(this)");
    item.setAttribute("ref", projs[i].res);
    var title = projs[i].title;
    if (title.length > 25)
      title = title.substring(0, 24) + " …";
    a.appendChild(document.createTextNode(title));
    div.firstChild.appendChild(document.createTextNode(projs[i].title));
    div.lastChild.appendChild(document.createTextNode(projs[i].desc));

    projlist.removeChild(projlist.lastChild);
    projlist.insertBefore(item, insertAfter.nextSibling);
  }
}


function projectLinkClicked (link) {
  top.openProjectByRes(link.parentNode.getAttribute("ref"));
}

// this reloads the iframe
function reload() {
  dump("--- splashpage.js reload\n");
  var pcFrame = document.getElementById("pcFrame");
  if (pcFrame)
    // pcFrame.src = "http://pc.celtx.com/html_feed.html";
    // pcFrame.src = "http://pc.celtx.com/projects/feed";
    pcFrame.src = top.Cx.PROJ_CENTRAL_URL + "projects/feed";
  var forumFrame = document.getElementById("forumFrame");
  if (forumFrame)
    // forumFrame.src = "http://forums.celtx.com/html_feed.php";
    forumFrame.src = top.Cx.FORUMS_URL + "html_feed.php";

  // Forum feed
  var req = new XMLHttpRequest();
  // req.open("GET", "http://forums.celtx.com/html_feed_count.php");
  req.open("GET", top.Cx.FORUMS_URL + "html_feed_count.php");
  var channel = req.channel;
  var prompt = new SuppressedAuthPrompt(channel.notificationCallbacks);
  channel.notificationCallbacks = prompt;
  req.onload = {
    request: req,
    handleEvent: function (evt) {
      if (this.request.status != 200) return;
      var txt = null;
      if (this.request.responseText == "0") {
        txt = document.createTextNode("");
      }
      else {
        txt = document.createTextNode("(" + this.request.responseText + ")");
      }
      var countspan = document.getElementById("forumCount");
      if (countspan.firstChild)
        countspan.replaceChild(txt, countspan.firstChild);
      else
        countspan.appendChild(txt);
    }
  };
  req.send(null);

  // PC feed
  req = new XMLHttpRequest();
  // req.open("GET", "http://pc.celtx.com/projects/count");
  req.open("GET", top.Cx.PROJ_CENTRAL_URL + "projects/count");
  var channel = req.channel;
  var prompt = new SuppressedAuthPrompt(channel.notificationCallbacks);
  channel.notificationCallbacks = prompt;
  req.onload = {
    request: req,
    handleEvent: function (evt) {
      if (this.request.status != 200) return;
      var countspan = document.getElementById("pcCount");
      var count = this.request.responseText.match(/NEW (\d+)/);
      var txt = null;
      if (! count || count.length < 2 || count[1] == "0") {
        txt = document.createTextNode("");
      }
      else {
        txt = document.createTextNode("(" + count[1] + ")");
      }
      if (countspan.firstChild)
        countspan.replaceChild(txt, countspan.firstChild);
      else
        countspan.appendChild(txt);
    }
  };
  req.send(null);

  var authMgr = top.getAuthManager();
  var authenticated = false;
  var domain = { value: null };
  var name = { value: null };
  var pwd = { value: null };
  try {
    authMgr.getAuthIdentity(top.Cx.AUTH_SCHEME, top.Cx.PUBLISH_SERVER,
      top.Cx.AUTH_PORT, top.Cx.AUTH_TYPE, top.Cx.AUTH_REALM, top.Cx.AUTH_PATH,
      domain, name, pwd);
    if (name.value && pwd.value)
      authenticated = true;
  }
  catch (ex) {}
  if (authenticated)
    addProjectFeeds();
}

function showFeed (feedname) {
  var feedframe = document.getElementById("feedFrame");
  var feedpicker = document.getElementById("feedpicker");
  var frames = feedframe.getElementsByTagName("iframe");
  var links = feedpicker.getElementsByTagName("a");
  for (var i = 0 ; i < frames.length; i++) {
    if (frames[i].id == feedname + "Frame") {
      links[i].className = "activefeed";
      frames[i].className = "";
      frames[i].src = frames[i].src;
    }
    else {
      links[i].className = "inactivefeed";
      frames[i].className = "dontshow";
    }
  }
}

function updateFeedFromElement (feed) {
  var title = feed.getAttribute("title");
  var unread = feed.getAttribute("unread");
  var uri = feed.getAttribute("uri");
  var feedid = uri.replace(/.*\//, "");
  var idx = -1;
  var feedframe = document.getElementById("feedFrame");
  var feedpicker = document.getElementById("feedpicker");
  var frames = feedframe.getElementsByTagName("iframe");
  var links = feedpicker.getElementsByTagName("a");
  for (var i = 0; i < frames.length; ++i) {
    if (frames[i].id == feedid + "Frame") {
      idx = i;
      break;
    }
  }
  if (idx < 0) return;
  frames[idx].src = frames[idx].src;
  var span = links[idx].firstChild;
  if (unread == "0")
    span.replaceChild(document.createTextNode(title), span.firstChild);
  else
    span.replaceChild(document.createTextNode(title + " (" + unread + ")"),
      span.firstChild);
}

function addFeedFromElement (feed) {
  var title = feed.getAttribute("title");
  var unread = feed.getAttribute("unread");
  var uri = feed.getAttribute("uri");
  var feedid = uri.replace(/.*\//, "");

  var framer = document.getElementById("feedFrame");
  var frame = document.createElementNS("http://www.w3.org/1999/xhtml",
    "iframe");
  frame.setAttribute("id", feedid + "Frame");
  frame.setAttribute("class", "dontshow");
  frame.setAttribute("frameborder", "0");
  frame.setAttribute("scrolling", "auto");
  frame.setAttribute("src", uri);
  framer.appendChild(frame);

  var picker = document.getElementById("feedpicker");
  var link = document.createElementNS("http://www.w3.org/1999/xhtml", "a");
  link.setAttribute("href", "javascript:showFeed('" + feedid + "');");
  var span = document.createElementNS("http://www.w3.org/1999/xhtml", "span");
  link.appendChild(span);
  span.setAttribute("class", "feedlink");
  if (unread == "0")
    span.appendChild(document.createTextNode(title));
  else
    span.appendChild(document.createTextNode(title + " (" + unread + ")"));
  picker.appendChild(link);
}

function addProjectFeeds () {
  var req = new XMLHttpRequest();
  req.open("GET", top.Cx.SERVER_BASEURL + "/app/inbox-feeds");
  var channel = req.channel;
  var prompt = new SuppressedAuthPrompt(channel.notificationCallbacks);
  channel.notificationCallbacks = prompt;
  req.onload = {
    request: req,
    handleEvent: function (evt) {
      if (this.request.status != 200) return;
      var feeds = this.request.responseXML.documentElement
        .getElementsByTagName("feed");
      for (var i = 0; i < feeds.length; ++i) {
        var uri = feeds[i].getAttribute("uri");
        var feedid = uri.replace(/.*\//, "");
        if (document.getElementById(feedid + "Frame"))
          updateFeedFromElement(feeds[i]);
        else
          addFeedFromElement(feeds[i]);
      }
    }
  };
  req.send(null);
}

function removeProjectFeeds () {
  var frames = document.getElementById("feedFrame")
    .getElementsByTagName("iframe");
  for (var i = frames.length - 1; i > 1; --i)
    frames[i].parentNode.removeChild(frames[i]);
  var links = document.getElementById("feedpicker")
    .getElementsByTagName("a");
  for (var i = links.length - 1; i > 1; --i)
    links[i].parentNode.removeChild(links[i]);
}

function toggleLogin () {
  var authMgr = top.getAuthManager();
  var authenticated = false;
  var domain = { value: null };
  var name = { value: null };
  var pwd = { value: null };
  try {
    authMgr.getAuthIdentity(top.Cx.AUTH_SCHEME, top.Cx.PUBLISH_SERVER,
      top.Cx.AUTH_PORT, top.Cx.AUTH_TYPE, top.Cx.AUTH_REALM, top.Cx.AUTH_PATH,
      domain, name, pwd);
    if (name.value && pwd.value)
      authenticated = true;
  }
  catch (ex) {
    dump("*** toggleLogin: " + ex + "\n");
  }
  if (authenticated) {
    var loginstr = top.gApp.getText("SplashLogIn");
    authMgr.clearAll();
    var welcomespan = document.getElementById("welcomespan");
    welcomespan.replaceChild(document.createTextNode(" "),
      welcomespan.firstChild);
    var loginspan = document.getElementById("loginspan");
    loginspan.replaceChild(document.createTextNode(loginstr),
      loginspan.firstChild);
    removeProjectFeeds();
  }
  else {
    top.gApp.authenticate("get-project", attemptedLogin);
  }
}

function attemptedLogin (succeeded) {
  dump("--- attemptedLogin: " + succeeded + "\n");
  var welcomestr = top.gApp.getText("SplashWelcome", [ top.gApp.userID ]);
  var logoutstr = top.gApp.getText("SplashLogOut");
  if (succeeded) {
    var welcomespan = document.getElementById("welcomespan");
    welcomespan.replaceChild(
      document.createTextNode(welcomestr + " | "),
      welcomespan.firstChild);
    var loginspan = document.getElementById("loginspan");
    loginspan.replaceChild(document.createTextNode(logoutstr),
      loginspan.firstChild);
    addProjectFeeds();
  }
  else {
    var pref = top.getPrefService().getBranch("celtx.");
    pref.clearUserPref("user.loginOnStartup");
  }
}

// load the init() function when the page is fully loaded
window.onload = init;
